#include <windows.h> 
#include <process.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h> 

#define FUNC __declspec(dllimport) __stdcall
extern "C" HANDLE FUNC OpenHidHandle(unsigned short vendor_id, unsigned short product_id);
extern "C" void FUNC ReadReport(HANDLE handle,unsigned char *InputReport,int *len);
extern "C" void FUNC WriteReport(HANDLE handle,unsigned char *OutputReport, int *len);
extern "C" void FUNC CloseHidHandle(HANDLE handle);

HANDLE hRsDevHandle;

// the device's vendor and product id
#define MY_VID   0x12BA    // Guitar Hero3 Controller for PLAYSTATION3
#define MY_PID   0x0100    //  "

#define MAXREPORTSIZE 256
int		InputLength,OutputLength;
unsigned char	InputReport[MAXREPORTSIZE];
unsigned char	OutputReport[MAXREPORTSIZE];

int				Guitar_axis1;
int				Guitar_axis2;
int				Guitar_axis3;
int				Guitar_button1;
int				Guitar_button2;
unsigned char buf[32];

int main()
{
	char path[256];
	unsigned char ibuf[32];
	int buflen;
	HANDLE h;
	
	printf("###########################################\n");
	printf("#                                         #\n");
	printf("#   PS3-Guitar Test version 0.2           #\n");
	printf("#                  build 2008-6-15        #\n");
	printf("#                                         #\n");
	printf("###########################################\n");
	printf("\n");
	
	h=OpenHidHandle( MY_VID , MY_PID );
	if (h==NULL) {
		printf("Device not found\n");
		getch(); exit(1);
	}
	printf("Opened.\n");
	
	while (1){
		
		if (kbhit()) { if (getch()==0x1B) break; }
		
		for (int i=0;i<32;i++) { ibuf[i]=0; }
		buflen=0;
		
		ReadReport( h, ibuf, &buflen );
		
		Guitar_button1= ibuf[1] + ibuf[2]*256;
		Guitar_button2= ibuf[3];
		Guitar_axis1 = ibuf[4];
		Guitar_axis2 = ibuf[5];
		Guitar_axis3 = ibuf[6];
		
		printf("Buttons = %04X, ",Guitar_button1);
		printf("Stick = %04X, ",Guitar_axis3);
		printf("POV = %04X \n",Guitar_button2);
		
		Sleep(100);
	}
	
	CloseHidHandle(h);
	printf("Closed.\n");
	
	return 0;
}
